"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

var _Text = _interopRequireDefault(require("./Text"));

var _Tooltip = _interopRequireDefault(require("./Tooltip"));

var _Avatar = _interopRequireDefault(require("./Avatar"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread(_objectSpread({}, _reactWithStyles.withStylesPropTypes), {}, {
  large: _propTypes.default.bool,
  micro: _propTypes.default.bool,
  small: _propTypes.default.bool,
  square: _propTypes.default.string,
  apps: _propTypes.default.array,
  showItems: _propTypes.default.number,
  messageTop: _propTypes.default.bool,
  messageBottom: _propTypes.default.bool,
  messageLeft: _propTypes.default.bool,
  messageRight: _propTypes.default.bool,
  rawCounter: _propTypes.default.number
});

var AvatarGroup = function AvatarGroup(_ref) {
  var css = _ref.css,
      large = _ref.large,
      micro = _ref.micro,
      small = _ref.small,
      square = _ref.square,
      styles = _ref.styles,
      apps = _ref.apps,
      _ref$showItems = _ref.showItems,
      showItems = _ref$showItems === void 0 ? 4 : _ref$showItems,
      messageTop = _ref.messageTop,
      messageBottom = _ref.messageBottom,
      messageRight = _ref.messageRight,
      messageLeft = _ref.messageLeft,
      rawCounter = _ref.rawCounter;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.container), apps.filter(function (app, count) {
    return count < showItems;
  }).map(function (app, key) {
    return /*#__PURE__*/_react.default.createElement("div", _extends({
      key: key
    }, css(styles.avatar, square && styles.squareAvatar)), /*#__PURE__*/_react.default.createElement(_Tooltip.default, {
      top: messageTop,
      left: messageLeft,
      right: messageRight,
      bottom: messageBottom,
      text: app && app.name
    }, /*#__PURE__*/_react.default.createElement(_Avatar.default, {
      source: app.icon,
      small: small,
      micro: micro,
      large: large,
      square: square
    })));
  }), rawCounter && /*#__PURE__*/_react.default.createElement("div", css(styles.others), /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: true,
    muted: true,
    bold: true
  }, "+".concat(rawCounter.toLocaleString("pt-BR")))), !rawCounter && apps.length > showItems && /*#__PURE__*/_react.default.createElement("div", css(styles.others), /*#__PURE__*/_react.default.createElement(_Tooltip.default, {
    top: messageTop,
    left: messageLeft,
    right: messageRight,
    bottom: messageBottom,
    text: apps.filter(function (app, count) {
      return count >= showItems;
    }).map(function (app, count) {
      return /*#__PURE__*/_react.default.createElement(_Text.default, {
        key: app ? app.name : count,
        micro: true,
        center: true,
        inverse: true,
        truncate: true
      }, app && app.name);
    })
  }, /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: true,
    muted: true,
    bold: true
  }, "+".concat(apps.length - showItems)))));
};

AvatarGroup.propTypes = propTypes;
var AvatarGroupWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color,
      units = _ref2.units,
      radius = _ref2.radius;
  return {
    container: {
      display: 'flex',
      alignItems: 'center',
      position: 'relateive'
    },
    avatar: {
      borderRadius: '50%',
      marginLeft: units(-1),
      backgroundColor: color.blueGray,
      boxShadow: '3px 3px 3px -1px #d3d3d3',
      ':nth-child(1)': {
        marginLeft: 0
      }
    },
    squareAvatar: {
      borderRadius: 0
    },
    others: {
      borderRadius: radius,
      cursor: 'pointer',
      marginLeft: units(0.8)
    }
  };
})(AvatarGroup);
var _default = AvatarGroupWithStyles;
exports.default = _default;