"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Transition = _interopRequireDefault(require("react-transition-group/Transition"));

var _withStyles = require("../helpers/withStyles");

var _Responsive = require("./Responsive");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread(_objectSpread({}, _reactWithStyles.withStylesPropTypes), {}, {
  showFor: _propTypes.default.oneOf(['small', 'medium', 'large', 'xlarge']),
  hideFor: _propTypes.default.oneOf(['small', 'medium', 'large', 'xlarge']),
  global: _propTypes.default.bool,
  primary: _propTypes.default.bool,
  visible: _propTypes.default.bool,
  onClick: _propTypes.default.func,
  onClose: _propTypes.default.func,
  zIndex: _propTypes.default.number
});

var Blanket = function Blanket(_ref) {
  var absolute = _ref.absolute,
      showFor = _ref.showFor,
      hideFor = _ref.hideFor,
      global = _ref.global,
      visible = _ref.visible,
      _onClick = _ref.onClick,
      onClose = _ref.onClose,
      primary = _ref.primary,
      zIndex = _ref.zIndex,
      styles = _ref.styles,
      css = _ref.css;
  return /*#__PURE__*/_react.default.createElement(_Transition.default, {
    in: visible,
    timeout: 300,
    mountOnEnter: true,
    unmountOnExit: true,
    onEnter: function onEnter(node) {
      return node.scrollTop;
    },
    onExited: function onExited() {
      return onClose && onClose();
    }
  }, function (state) {
    return /*#__PURE__*/_react.default.createElement(_Responsive.Responsive, {
      showFor: showFor,
      hideFor: hideFor
    }, /*#__PURE__*/_react.default.createElement("div", _extends({}, css(styles.blanket, absolute ? styles.blanket_absolute : styles.blanket_fixed, global && styles.blanket_global, primary && styles.blanket_primary, (state === 'entering' || state === 'entered') && styles.blanket_entering, (state === 'exiting' || state === 'exited') && styles.blanket_exiting, {
      zIndex: zIndex
    }), {
      onClick: function onClick() {
        return _onClick && _onClick();
      }
    })));
  });
};

Blanket.propTypes = propTypes;
var BlanketWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color;
  return {
    blanket: {
      width: '100%',
      height: '100%',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0,
      zIndex: 99,
      background: color.white,
      opacity: 0.75,
      transition: 'opacity 300ms ease-out'
    },
    blanket_absolute: {
      position: 'absolute'
    },
    blanket_fixed: {
      position: 'fixed'
    },
    blanket_global: {
      zIndex: 101
    },
    blanket_primary: {
      background: color.primary
    },
    //transitions
    blanket_entering: {
      opacity: 0.75,
      transition: 'opacity 300ms ease-out'
    },
    blanket_exiting: {
      opacity: 0.01,
      transition: 'opacity 300ms ease-out'
    }
  };
})(Blanket);
var _default = BlanketWithStyles;
exports.default = _default;