"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

var _Text = _interopRequireDefault(require("./Text"));

var _Spacing = _interopRequireDefault(require("./Spacing"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread(_objectSpread({}, _reactWithStyles.withStylesPropTypes), {}, {
  children: _propTypes.default.any,
  actionLink: _propTypes.default.any,
  errorMessage: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  hideLabel: _propTypes.default.bool,
  id: _propTypes.default.string,
  inline: _propTypes.default.bool,
  invalid: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  labelDescription: _propTypes.default.string,
  large: _propTypes.default.bool,
  lightLabel: _propTypes.default.bool,
  small: _propTypes.default.bool
});

var FormElement = function FormElement(_ref) {
  var actionLink = _ref.actionLink,
      children = _ref.children,
      css = _ref.css,
      errorMessage = _ref.errorMessage,
      hideLabel = _ref.hideLabel,
      id = _ref.id,
      inline = _ref.inline,
      invalid = _ref.invalid,
      inverse = _ref.inverse,
      label = _ref.label,
      labelDescription = _ref.labelDescription,
      large = _ref.large,
      lightLabel = _ref.lightLabel,
      small = _ref.small,
      styles = _ref.styles;
  return /*#__PURE__*/_react.default.createElement("label", css(styles.formElement, !inline && styles.block), /*#__PURE__*/_react.default.createElement("div", css(styles.label, hideLabel && styles.label_hidden), typeof label === 'string' ? /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: true,
    bold: !lightLabel,
    light: lightLabel
  }, label) : label, labelDescription && /*#__PURE__*/_react.default.createElement(_Spacing.default, {
    top: 0.5
  }, /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: true,
    light: true
  }, labelDescription))), children, invalid && errorMessage && /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: true,
    error: true
  }, errorMessage));
};

FormElement.propTypes = propTypes;
var FormElementWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var units = _ref2.units;
  return {
    formElement: {
      display: 'inline-block'
    },
    block: {
      display: 'block',
      width: '100%'
    },
    label: {
      marginBottom: units(0.5)
    },
    label_hidden: {
      border: 0,
      clip: 'rect(0, 0, 0, 0)',
      display: 'block',
      height: 1,
      margin: -1,
      overflow: 'hidden',
      padding: 0,
      position: 'absolute',
      width: 1
    }
  };
})(FormElement);
var _default = FormElementWithStyles;
exports.default = _default;