"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

var _Spacing = _interopRequireDefault(require("./Spacing"));

var _Text = _interopRequireDefault(require("./Text"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread(_objectSpread({}, _reactWithStyles.withStylesPropTypes), {}, {
  actionLink: _propTypes.default.any,
  children: _propTypes.default.any,
  collapseSpacing: _propTypes.default.bool,
  errorMessage: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  hideLabel: _propTypes.default.bool,
  invalid: _propTypes.default.bool,
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  labelDescription: _propTypes.default.string,
  lightLabel: _propTypes.default.bool
});

var FormElementGroup = function FormElementGroup(_ref) {
  var actionLink = _ref.actionLink,
      children = _ref.children,
      collapseSpacing = _ref.collapseSpacing,
      css = _ref.css,
      errorMessage = _ref.errorMessage,
      hideLabel = _ref.hideLabel,
      invalid = _ref.invalid,
      label = _ref.label,
      labelDescription = _ref.labelDescription,
      lightLabel = _ref.lightLabel,
      styles = _ref.styles;
  return /*#__PURE__*/_react.default.createElement("fieldset", css(styles.formElementGroup), /*#__PURE__*/_react.default.createElement("legend", css(styles.formElementGroup__legend), typeof label === 'string' ? /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: true,
    bold: !lightLabel,
    light: lightLabel
  }, label) : label), labelDescription && /*#__PURE__*/_react.default.createElement(_Spacing.default, {
    top: 0.5
  }, /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: true,
    light: true
  }, labelDescription)), /*#__PURE__*/_react.default.createElement(_Spacing.default, {
    vertical: collapseSpacing ? 0 : 1
  }, children), invalid && errorMessage && /*#__PURE__*/_react.default.createElement(_Text.default, {
    small: true,
    error: true
  }, errorMessage));
};

FormElementGroup.propTypes = propTypes;
var FormElementGroupWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var units = _ref2.units;
  return {
    formElementGroup: {
      border: 0,
      margin: 0,
      padding: 0
    },
    formElementGroup__legend: {
      padding: 0,
      margin: 0
    }
  };
})(FormElementGroup);
var _default = FormElementGroupWithStyles;
exports.default = _default;