"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _InputOnly = _interopRequireDefault(require("./InputOnly"));

var _Spacing = _interopRequireDefault(require("./Spacing"));

var _reactGoogleMaps = require("react-google-maps");

var _DrawingManager = _interopRequireDefault(require("react-google-maps/lib/components/drawing/DrawingManager"));

var _SearchBox = _interopRequireDefault(require("react-google-maps/lib/components/places/SearchBox"));

var _MarkerClusterer = _interopRequireDefault(require("react-google-maps/lib/components/addons/MarkerClusterer"));

var _CinnectaTheme = _interopRequireDefault(require("../themes/CinnectaTheme"));

var _MapCircle = _interopRequireDefault(require("./MapCircle"));

var _MapPolygon = _interopRequireDefault(require("./MapPolygon"));

var _excluded = ["apiKey", "children", "defaultCenter", "isCenterMarkerVisible", "editMode", "highlightShape", "onClickShape", "onMouseOutShape", "onMouseOverShape", "places", "removeMarkers", "shapes"],
    _excluded2 = ["defaultCenter", "mapMoved", "mapLoaded", "zoomChanged"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  children: _propTypes.default.any,
  defaultZoom: _propTypes.default.number,
  defaultCenter: _propTypes.default.object,
  defaultClickableIcons: _propTypes.default.bool,
  editMode: _propTypes.default.bool,
  isCenterMarkerVisible: _propTypes.default.bool,
  places: _propTypes.default.bool,
  removeMarkers: _propTypes.default.bool,
  shapes: _propTypes.default.array,
  shapesToEnframe: _propTypes.default.array
};
var defaultProps = {
  defaultZoom: 5,
  defaultCenter: {
    lat: -19.932231,
    lng: -43.9266687
  },
  isCenterMarkerVisible: false,
  defaultOptions: {
    streetViewControl: false,
    scaleControl: false,
    mapTypeControl: false,
    panControl: false,
    zoomControl: false,
    rotateControl: false,
    fullscreenControl: false,
    clickableIcons: false,
    disableDefaultUI: true,
    styles: _CinnectaTheme.default.map
  },
  defaultClickableIcons: false
};
var shapeOptions = {
  fillColor: '#ee430e',
  strokeColor: '#ee430e',
  strokeWeight: 1,
  fillOpacity: .3,
  strokeOpacity: .5
};

var Map = /*#__PURE__*/function (_Component) {
  _inherits(Map, _Component);

  var _super = _createSuper(Map);

  function Map(props) {
    var _this;

    _classCallCheck(this, Map);

    _this = _super.call(this, props);
    _this.shapes = {};
    _this.state = {
      google: null,
      pristine: true
    };
    return _this;
  }

  _createClass(Map, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.shapesToEnframe) {
        this.centerOnShapes(this.props.shapesToEnframe);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      //if(prevProps.shapesToEnframe !== this.props.shapesToEnframe) {
      if (!_lodash.default.isEqual(prevProps.shapesToEnframe, this.props.shapesToEnframe)) {
        this.centerOnShapes(this.props.shapesToEnframe);
      }
    }
  }, {
    key: "mapLoaded",
    value: function mapLoaded(ref) {
      var _this2 = this;

      if (ref && this.state.pristine) {
        this.map = ref;
        var google = ref.props.google;
        this.props.onMapLoaded && this.props.onMapLoaded(google);

        if (this.state.google !== google) {
          this.setState({
            google: google,
            pristine: false
          }, function () {
            return _this2.centerOnShapes(_this2.props.shapes);
          });
        }
      }
    }
  }, {
    key: "centerOnShapes",
    value: function centerOnShapes(shapes) {
      var google = this.state.google;

      if (shapes && shapes.length > 0 && google) {
        var bounds = new google.maps.LatLngBounds();
        shapes.map(function (shape) {
          if (shape.type === 'circle') {
            var _shape$center = shape.center,
                lat = _shape$center.lat,
                lng = _shape$center.lng;
            var latLng = new google.maps.LatLng(lat, lng);
            var latOffset = shape.radius / 111320;
            var lngOffset = shape.radius / (40075000 * Math.cos(lat) / 360);
            var leftLatLng = new google.maps.LatLng(lat - latOffset, lng);
            var rightLatLng = new google.maps.LatLng(lat + latOffset, lng);
            var topLatLng = new google.maps.LatLng(lat, lng - lngOffset);
            var bottomLatLng = new google.maps.LatLng(lat, lng + lngOffset);
            bounds.extend(latLng);
            bounds.extend(leftLatLng);
            bounds.extend(rightLatLng);
            bounds.extend(topLatLng);
            bounds.extend(bottomLatLng);
          } else {
            shape.path.map(function (node) {
              var lat = node.lat,
                  lng = node.lng;
              var latLng = new google.maps.LatLng(lat, lng);
              bounds.extend(latLng);
              return true;
            });
          }

          return true;
        });
        this.map.fitBounds(bounds);
      }
    }
  }, {
    key: "mapMoved",
    value: function mapMoved() {
      this.props.onMapMoved && this.props.onMapMoved(this.map.getCenter()); //console.log('mapMoved: ' + JSON.stringify(this.map.getCenter()))
    }
  }, {
    key: "zoomChanged",
    value: function zoomChanged() {
      this.props.onZoomChanged && this.props.onZoomChanged(this.map.getZoom()); //console.log(this.map.getZoom())
    }
  }, {
    key: "placesChanged",
    value: function placesChanged(places) {
      places && places[0] && this.map.fitBounds(places[0].geometry.viewport);
      this.props.onPlacesChanged && this.props.onPlacesChanged(places);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props = this.props,
          apiKey = _this$props.apiKey,
          children = _this$props.children,
          defaultCenter = _this$props.defaultCenter,
          isCenterMarkerVisible = _this$props.isCenterMarkerVisible,
          editMode = _this$props.editMode,
          highlightShape = _this$props.highlightShape,
          onClickShape = _this$props.onClickShape,
          onMouseOutShape = _this$props.onMouseOutShape,
          onMouseOverShape = _this$props.onMouseOverShape,
          places = _this$props.places,
          removeMarkers = _this$props.removeMarkers,
          shapes = _this$props.shapes,
          rest = _objectWithoutProperties(_this$props, _excluded);

      var google = this.state.google;
      return (
        /*#__PURE__*/
        //google &&
        _react.default.createElement(MapComponent, _extends({
          loadingElement: /*#__PURE__*/_react.default.createElement("div", {
            style: {
              height: "100%"
            }
          }),
          containerElement: /*#__PURE__*/_react.default.createElement("div", {
            style: {
              height: "100%"
            }
          }),
          mapElement: /*#__PURE__*/_react.default.createElement("div", {
            style: {
              height: "100%"
            }
          }),
          googleMapURL: "https://maps.googleapis.com/maps/api/js?key=".concat(apiKey, "&language=pt-BR&v=3.exp&libraries=geometry,drawing,places"),
          defaultCenter: defaultCenter,
          mapMoved: function mapMoved() {
            return _this3.mapMoved();
          },
          zoomChanged: function zoomChanged() {
            return _this3.zoomChanged();
          },
          mapLoaded: function mapLoaded(ref) {
            return _this3.mapLoaded(ref);
          }
        }, rest), isCenterMarkerVisible && /*#__PURE__*/_react.default.createElement(_reactGoogleMaps.Marker, {
          position: defaultCenter
        }), editMode && google && /*#__PURE__*/_react.default.createElement(_DrawingManager.default, {
          defaultDrawingMode: google.maps.drawing.OverlayType.CIRCLE,
          defaultOptions: {
            drawingControl: true,
            drawingControlOptions: {
              position: google.maps.ControlPosition.TOP_RIGHT,
              drawingModes: [google.maps.drawing.OverlayType.CIRCLE, google.maps.drawing.OverlayType.POLYGON]
            },
            circleOptions: {
              fillColor: "#68A7F0",
              strokeWeight: 0,
              clickable: false,
              editable: true,
              zIndex: 1
            },
            polygonOptions: {
              fillColor: "#68A7F0",
              strokeWeight: 0,
              clickable: false,
              editable: true,
              zIndex: 1
            }
          }
        }), places && google && /*#__PURE__*/_react.default.createElement(_SearchBox.default, {
          ref: function ref(_ref) {
            return _this3.searchBox = _ref;
          },
          controlPosition: google.maps.ControlPosition.TOP_LEFT,
          onPlacesChanged: function onPlacesChanged() {
            return _this3.searchBox && _this3.placesChanged(_this3.searchBox.getPlaces());
          },
          onClose: function onClose() {},
          showSearchBox: true,
          onSelectStory: function onSelectStory() {}
        }, /*#__PURE__*/_react.default.createElement("div", {
          style: {
            maxWidth: 540,
            width: '100%',
            opacity: .9
          }
        }, /*#__PURE__*/_react.default.createElement(_Spacing.default, {
          top: 1,
          left: 1
        }, /*#__PURE__*/_react.default.createElement(_InputOnly.default, {
          floating: true,
          type: "text",
          placeholder: "Pesquise no mapa...",
          name: "googlePlaces"
        })))), /*#__PURE__*/_react.default.createElement(_MarkerClusterer.default, {
          averageCenter: true,
          enableRetinaIcons: true,
          gridSize: 60,
          maxZoom: 13,
          minimumClusterSize: 1
        }, shapes && shapes.map(function (shape) {
          if (shape.type === 'circle') {
            return /*#__PURE__*/_react.default.createElement(_MapCircle.default, {
              key: shape.id //ref={ref => this.shapes[shape.id] = ref}
              ,
              center: shape.center,
              radius: shape.radius,
              editable: shape.editable,
              draggable: shape.draggable,
              options: _objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread({}, shapeOptions), shape.color && {
                fillColor: shape.color
              }), highlightShape === shape.id && {
                fillColor: 'yellow'
              }), shape.color && {
                strokeColor: shape.color
              }), shape.strokeColor && {
                strokeColor: shape.strokeColor
              }), shape.opacity && {
                fillOpacity: shape.opacity,
                strokeOpacity: shape.opacity
              }), shape.strokeOpacity && {
                strokeOpacity: shape.strokeOpacity
              }),
              removeMarker: removeMarkers,
              onClick: function onClick() {
                return onClickShape && onClickShape(shape);
              },
              onMouseOver: function onMouseOver() {
                return onMouseOverShape && onMouseOverShape(shape);
              },
              onMouseOut: function onMouseOut() {
                return onMouseOutShape && onMouseOutShape(shape);
              }
            });
          } else {
            return /*#__PURE__*/_react.default.createElement(_MapPolygon.default, {
              key: shape.id //ref={ref => this.shapes[shape.id] = ref}
              ,
              path: shape.path,
              options: _objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread({}, shapeOptions), shape.color && {
                fillColor: shape.color
              }), highlightShape === shape.id && {
                fillColor: 'yellow'
              }), shape.color && {
                strokeColor: shape.color
              }), shape.strokeColor && {
                strokeColor: shape.strokeColor
              }), shape.opacity && {
                fillOpacity: shape.opacity,
                strokeOpacity: shape.opacity
              }), shape.strokeOpacity && {
                strokeOpacity: shape.strokeOpacity
              }),
              removeMarker: removeMarkers,
              onClick: function onClick() {
                return onClickShape && onClickShape(shape);
              },
              onMouseOver: function onMouseOver() {
                return onMouseOverShape && onMouseOverShape(shape);
              },
              onMouseOut: function onMouseOut() {
                return onMouseOutShape && onMouseOutShape(shape);
              }
            });
          }
        }), children))
      );
    }
  }]);

  return Map;
}(_react.Component);

Map.propTypes = propTypes;
Map.defaultProps = defaultProps;
var MapComponent = (0, _reactGoogleMaps.withScriptjs)((0, _reactGoogleMaps.withGoogleMap)(function (_ref2) {
  var defaultCenter = _ref2.defaultCenter,
      mapMoved = _ref2.mapMoved,
      mapLoaded = _ref2.mapLoaded,
      zoomChanged = _ref2.zoomChanged,
      props = _objectWithoutProperties(_ref2, _excluded2);

  return /*#__PURE__*/_react.default.createElement(_reactGoogleMaps.GoogleMap, _extends({
    defaultCenter: defaultCenter,
    onIdle: mapMoved,
    ref: mapLoaded,
    onZoomChanged: zoomChanged,
    google: window.google
  }, props), props.children);
}));
var _default = Map;
exports.default = _default;