"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread(_objectSpread({}, _reactWithStyles.withStylesPropTypes), {}, {
  large: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  micro: _propTypes.default.bool,
  small: _propTypes.default.bool,
  square: _propTypes.default.bool,
  progression: _propTypes.default.number
});

var ProgressBar = function ProgressBar(_ref) {
  var css = _ref.css,
      large = _ref.large,
      loading = _ref.loading,
      micro = _ref.micro,
      small = _ref.small,
      square = _ref.square,
      progression = _ref.progression,
      styles = _ref.styles;

  var getProgression = function getProgression() {
    return progression <= 7 ? 7 : progression;
  };

  return /*#__PURE__*/_react.default.createElement("div", css(styles.container), /*#__PURE__*/_react.default.createElement("div", css(styles.progression), "".concat(progression, "%")), /*#__PURE__*/_react.default.createElement("div", css(styles.progressBar, styles.outsideProgressBar, large && styles.outsideProgressBar_large, micro && styles.outsideProgressBar_micro, small && styles.outsideProgressBar_small, square && styles.progressBar_square, !micro && !small && !large && styles.outsideProgressBar_medium), /*#__PURE__*/_react.default.createElement("div", css(styles.progressBar, styles.insideProgressBar, square && styles.progressBar_square, loading && styles.insideProgressBar_loading, {
    width: "".concat(getProgression(), "%")
  }))));
};

ProgressBar.propTypes = propTypes;
var ProgressBarWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color,
      units = _ref2.units,
      radius = _ref2.radius;
  return {
    container: {
      display: 'inline-block'
    },
    progressBar: {
      borderRadius: units(0.5)
    },
    outsideProgressBar: {
      backgroundColor: '#e5e5e5',
      position: 'relative',
      boxShadow: 'inset 1px 2px 5px #c1c1c1'
    },
    insideProgressBar: {
      backgroundColor: color.secondary,
      backgroundImage: 'linear-gradient(to right, #055bad , #00d4ff)',
      height: '100%',
      maxWidth: '100%',
      position: 'absolute'
    },
    outsideProgressBar_micro: {
      width: units(5),
      height: units(0.8)
    },
    outsideProgressBar_small: {
      width: units(10),
      height: units(0.8)
    },
    outsideProgressBar_medium: {
      width: units(15),
      height: units(0.8)
    },
    outsideProgressBar_large: {
      width: units(20),
      height: units(0.8)
    },
    progressBar_square: {
      borderRadius: radius * 0.5
    },
    insideProgressBar_loading: {
      backgroundColor: color.blueGray,
      backgroundImage: "None"
    },
    progression: {
      textAlign: 'right',
      marginBottom: units(0.1),
      fontSize: units(1.2)
    }
  };
})(ProgressBar);
var _default = ProgressBarWithStyles;
exports.default = _default;