"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

var _Loader = _interopRequireDefault(require("./Loader"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread(_objectSpread({}, _reactWithStyles.withStylesPropTypes), {}, {
  loading: _propTypes.default.bool,
  header: _propTypes.default.array,
  body: _propTypes.default.array
});

var Table = function Table(_ref) {
  var css = _ref.css,
      loading = _ref.loading,
      header = _ref.header,
      body = _ref.body,
      styles = _ref.styles;
  return /*#__PURE__*/_react.default.createElement("div", css(styles.table_container), /*#__PURE__*/_react.default.createElement("div", css(styles.flex_table), header.map(function (column, key) {
    return /*#__PURE__*/_react.default.createElement("div", _extends({
      key: key
    }, css(styles.flex_row)), column);
  })), loading ? /*#__PURE__*/_react.default.createElement("div", css(styles.flex_loading), /*#__PURE__*/_react.default.createElement(_Loader.default, {
    primary: true
  })) : body.map(function (line, key) {
    return /*#__PURE__*/_react.default.createElement("div", _extends({
      key: key
    }, css(styles.flex_table)), line.map(function (column, i) {
      return /*#__PURE__*/_react.default.createElement("div", _extends({
        key: i
      }, css(styles.flex_row)), column);
    }));
  }));
};

Table.propTypes = propTypes;
var TableWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var _flex_row;

  var color = _ref2.color,
      units = _ref2.units,
      font = _ref2.font,
      breakpoint = _ref2.breakpoint;
  return {
    table_container: {
      display: 'block',
      margin: 'auto',
      width: '100%',
      fontFamily: font.default
    },
    flex_table: {
      display: 'flex',
      flexDirection: 'row',
      flexWrap: "wrap",
      transitionDuration: '0.5s',
      ":nth-child(1)": {
        backgroundColor: '#edf1f5'
      }
    },
    flex_row: (_flex_row = {
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center',
      width: 'calc(100% / 4)',
      textAlign: 'center',
      // padding: '0.5em 0.5em', //Padding e border right/left faz com que não caiba a conta certinha do width.
      paddingTop: '0.5em',
      paddingBottom: '0.5em'
    }, _defineProperty(_flex_row, breakpoint.medium, {
      width: 'calc(100% / 3)',
      ':nth-child(1)': {
        width: '100%',
        paddingTop: '1.5em',
        paddingBottom: '1.5em'
      }
    }), _defineProperty(_flex_row, breakpoint.small, {
      borderBottom: 0,
      width: '100%',
      ':nth-child(1)': {
        borderBottom: 'solid 1px #d9d9d9',
        width: '100%'
      }
    }), _flex_row),
    flex_loading: {
      width: '100%',
      padding: '0.5em 0.5em'
    }
  };
})(Table);
var _default = TableWithStyles;
exports.default = _default;