"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _Text = _interopRequireDefault(require("./Text"));

var _withStyles = require("../helpers/withStyles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } Object.defineProperty(subClass, "prototype", { value: Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }), writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Tooltip = /*#__PURE__*/function (_Component) {
  _inherits(Tooltip, _Component);

  var _super = _createSuper(Tooltip);

  function Tooltip(props) {
    var _this;

    _classCallCheck(this, Tooltip);

    _this = _super.call(this, props);
    _this.state = {
      visible: false
    };
    _this.hideTooltip = _this.hideTooltip.bind(_assertThisInitialized(_this));
    _this.showTooltip = _this.showTooltip.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Tooltip, [{
    key: "hideTooltip",
    value: function hideTooltip() {
      this.setState({
        visible: false
      });
    }
  }, {
    key: "showTooltip",
    value: function showTooltip() {
      this.setState({
        visible: true
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          disabled = _this$props.disabled,
          bottom = _this$props.bottom,
          children = _this$props.children,
          css = _this$props.css,
          left = _this$props.left,
          right = _this$props.right,
          styles = _this$props.styles,
          text = _this$props.text,
          top = _this$props.top;
      var visible = this.state.visible;
      return /*#__PURE__*/_react.default.createElement("div", _extends({}, css(styles.tooltip), {
        onMouseLeave: !disabled && this.hideTooltip
      }), visible && /*#__PURE__*/_react.default.createElement("div", css(styles.tooltip__bubble, top && styles.tooltip_top, right && styles.tooltip_right, bottom && styles.tooltip_bottom, left && styles.tooltip_left), /*#__PURE__*/_react.default.createElement("div", css(styles.tooltip__message), typeof text === 'string' || typeof text === 'number' ? /*#__PURE__*/_react.default.createElement(_Text.default, {
        micro: true,
        center: true,
        inverse: true
      }, text) : /*#__PURE__*/_react.default.createElement(_react.Fragment, null, text))), /*#__PURE__*/_react.default.createElement("span", {
        onMouseOver: !disabled && this.showTooltip
      }, children));
    }
  }]);

  return Tooltip;
}(_react.Component);

var _default = (0, _withStyles.withStyles)(function (_ref) {
  var color = _ref.color,
      radius = _ref.radius,
      units = _ref.units;
  return {
    tooltip: {
      position: 'relative'
    },
    tooltip__bubble: {
      minWidth: 160,
      maxWidth: 240,
      position: 'absolute',
      zIndex: 10
    },
    tooltip_top: {
      bottom: '100%',
      left: '50%',
      paddingBottom: units(0.5),
      transform: 'translateX(-50%)'
    },
    tooltip_bottom: {
      top: '100%',
      left: '50%',
      paddingTop: units(0.5),
      transform: 'translateX(-50%)'
    },
    tooltip_left: {
      top: '50%',
      right: '100%',
      paddingRight: units(0.5),
      transform: 'translateY(-50%)'
    },
    tooltip_right: {
      top: '50%',
      left: '100%',
      paddingLeft: units(0.5),
      transform: 'translateY(-50%)'
    },
    tooltip__message: {
      background: color.grayDarker,
      borderRadius: radius,
      padding: units(0.25)
    }
  };
})(Tooltip);

exports.default = _default;